CREATE OR REPLACE PROCEDURE WMS_SS_CLEANUP_DELETED_OBJECTS IS
/******************************************************************************
   NAME:       WMS_SS_CLEANUP_DELETED_OBJECTS
   PURPOSE:    

   REVISIONS:
   Ver        Date        Author           Description
   ---------  ----------  ---------------  ------------------------------------
   1.0        1/25/2006          1. Created this procedure.

   NOTES:

   Automatically available Auto Replace Keywords:
      Object Name:     WMS_SS_CLEANUP_DELETED_OBJECTS
      Sysdate:         1/25/2006
      Date and Time:   1/25/2006, 4:37:58 PM, and 1/25/2006 4:37:58 PM
      Username:         (set in TOAD Options, Procedure Editor)
      Table Name:       (set in the "New PL/SQL Object" dialog)

******************************************************************************/
		-- this is much time (in days) before a record marked for deletion is actually deleted
		delete_buffer_time NUMBER := 14;
BEGIN

	-- group 
	DELETE FROM wms_ss_group WHERE deleted='Y' AND SYSDATE-date_updated > delete_buffer_time;
	COMMIT;
	-- framework 
	DELETE FROM wms_ss_framework WHERE deleted='Y' AND SYSDATE-date_updated > delete_buffer_time;
	COMMIT;
	-- block 
	DELETE FROM wms_ss_block WHERE deleted='Y' AND SYSDATE-date_updated > delete_buffer_time;
	COMMIT;
	-- slot 
	DELETE FROM wms_ss_slot WHERE deleted='Y' AND SYSDATE-date_updated > delete_buffer_time;
	COMMIT;
	-- access 
	DELETE FROM wms_ss_access WHERE deleted='Y' AND SYSDATE-date_updated > delete_buffer_time;
	COMMIT;
	-- admin 
	DELETE FROM wms_ss_admin WHERE deleted='Y' AND SYSDATE-date_updated > delete_buffer_time;
	COMMIT;
	 
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       NULL;
     WHEN OTHERS THEN
       -- Consider logging the error and then re-raise
       RAISE;
END WMS_SS_CLEANUP_DELETED_OBJECTS;
/
