<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<bbUI:docTemplate>
<%
User curUser = ctx.getUser();
int userPkNum = DataUtil.getPkFromBbId(ctx.getUserId()); 
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");

String sheetGroupIdStr = request.getParameter("sheetGroupId");
int sheetGroupId = Integer.parseInt(sheetGroupIdStr);
SheetGroup curSheetGroup = SheetGroup.loadByGroupId(sheetGroupId);

String saveButtonName = "saveButton";
if (request.getParameter(saveButtonName) != null)
{
    curSheetGroup.setName(request.getParameter("name"));
    curSheetGroup.setDescription(request.getParameter("description"));
    curSheetGroup.setMaxTotalSlotsPerUser(Integer.parseInt(request.getParameter("maxTotalSlotsPerUser")));
    curSheetGroup.setMaxPendingSlotsPerUser(Integer.parseInt(request.getParameter("maxPendingSlotsPerUser")));
    curSheetGroup.save();
}
String name = curSheetGroup.getName();
String dateCreated = SqlUtil.dateFormatter.format(curSheetGroup.getDateCreated());
String dateUpdated = SqlUtil.dateFormatter.format(curSheetGroup.getDateUpdated());
String description = curSheetGroup.getDescription();
boolean isDefault = curSheetGroup.getIsDefault();
int maxTotalSlotsPerUser = curSheetGroup.getMaxTotalSlotsPerUser();
int maxPendingSlotsPerUser = curSheetGroup.getMaxPendingSlotsPerUser();

String newGroupStr = request.getParameter("isNew");
newGroupStr = (newGroupStr == null)?"":newGroupStr;
boolean isNewGroup =  newGroupStr.equalsIgnoreCase("true");

String actionMessage = request.getParameter("actionMessage");

FrameworkList fl = FrameworkList.loadByGroupId(sheetGroupId);
%>

<table>
 <tr>
  <td>
<%
if (actionMessage != null)
{
    %><span style="font-size:16pt; font-weight: bold; font-family: arial, sans-serif; color: green;"><%=actionMessage%></span><%
}
%>
  
<h2>Information for the sheet group <%=name%></h2>

<form action="ss_admin_mod_group_step1.jsp" method="GET">
  <input type="hidden" name="sheetGroupId" value="<%=sheetGroupIdStr%>">
  <input type="hidden" name="actionMessage" value="Saved">
<table>
<%
if (isDefault)
{
    %> <tr><td style="font-size:16pt; font-weight: bold; text-align: center; color: blue;" colspan="2">This is your default group</td></tr>
<%
}
%>
 <tr>
  <td align="right">Name:</td>
  <td align="left"><input type="text" name="name" value="<%=name%>" SIZE="16" MAXLENGTH="64"> (<i>created on <%=dateCreated%>, last updated on <%=dateUpdated%></i>)</td>
 </tr>
 <tr>
  <td align="right">Brief Desription<br>(255 character max)</td>
  <td align="left"><textarea name="description" rows="4" cols="60"><%=description%></textarea></td>
 </tr>
 <tr>
  <td align="right">Maximum Total<br>Signups Per User</td>
  <td align="left">
    <select name="maxTotalSlotsPerUser">
        <option value="-1"<%=(maxTotalSlotsPerUser==-1?" selected":"")%>>Unlimited</option>
<%
    for (int limitNum = 1; limitNum <= 12; limitNum++)
    {
        ;%><option value="<%=limitNum%>"<%=(maxTotalSlotsPerUser==limitNum?" selected":"")%>><%=limitNum%></option><%
    }
%>
    </select> This is the total number of times a users can sign up on all sheets in this group combined. Leave it at 'Unlimited' if you don't care how many times a user signs up.
  </td>
 </tr>
 <tr>
  <td align="right">Maximum Pending<br>Signups Per User</td>
  <td align="left">
    <select name="maxPendingSlotsPerUser">
        <option value="-1"<%=(maxPendingSlotsPerUser==-1?" selected":"")%>>Unlimited</option>
<%
    for (int limitNum = 1; limitNum <= 12; limitNum++)
    {
        %><option value="<%=limitNum%>"<%=(maxPendingSlotsPerUser==limitNum?" selected":"")%>><%=limitNum%></option><%
    }
%>
    </select>
  </td> This is the total number of signups in the future a user can have across all sheets in this group.  Leave it at 'Unlimited' if you don't care how many times in advance a user signs up.
 </tr>
 <%
if (fl.size() > 0)
{
    %> <tr><td valign="top" align="right">Signup sheets in this group</td>
  <td valign="top" align="left">
<%
    for (int flIndex = 0; flIndex < fl.size(); flIndex++)
    {
        Framework f = (Framework)fl.get(flIndex);
        String fName = f.getName();
        int frameworkId = f.getFrameworkId();
        %>  <a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step1.jsp?frameworkId=<%=frameworkId%>"><%=fName%></a><br>
<%
    }
    %>  </td>
 </tr><%
}
 %>
</table>
<br>
<center><input style="background-color:#99DD99; font-size:16pt;" type="submit" name="<%=saveButtonName%>" value="Save this sheet group"></center>
</form>
<%
if (! isDefault)
{
    String deleteText = isNewGroup?"Discard this new sheet group":"Delete this sheet group";
    String deleteConfirmText = isNewGroup?"You are about to discard this new sheet group.":"You are about to delete this group and move all the sheets in it to your default group.";
%>
<form style="text-align: right;" action="ss_admin_del_group.jsp" method="GET">
<input type="hidden" name="sheetGroupId" value="<%=sheetGroupIdStr%>">
<input style="background-color:#DD9999; font-size:14pt;" type="submit" name="delete_this" value="<%=deleteText%>" onclick="return confirm('<%=deleteConfirmText%> Click OK to do so, and Cancel to abort.')">
</form>
<%
}
%>
  <td>
 <tr>
<table>

</bbUI:docTemplate>
</bbData:context>

