<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">

<%
User curUser = ctx.getUser();
String userPk = ctx.getUserId().toExternalString();
int userPkNum = Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
%>

<bbUI:docTemplate>

Administrator Signup Sheet Module for <%=userName%> - upcoming signups:

<!-- list of impending (in next week) blocks that have signups<br>
with link <a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step2.jsp">mod block</a> for each one. -->

<ul>
<%
Calendar cal = Calendar.getInstance();
Date startDate = cal.getTime();
int dayLookAhead = 6;
cal.add(Calendar.DATE, dayLookAhead);
BlockList bl = wms.ss.data.BlockList.loadUsedByOwnerUserId(userPkNum,startDate,cal.getTime());
Iterator bli = bl.listIterator();

SimpleDateFormat startDateFormatter = new SimpleDateFormat("EEEE MM/dd h:mm");
SimpleDateFormat endDateFormatter = new SimpleDateFormat("h:mm a");
if (bl.isEmpty())
{
    %><li>No signups in the next <%=dayLookAhead%> days</li><%
}
else 
{
    while (bli.hasNext())
    {
            Block b = (Block)bli.next();
            Framework f = Framework.loadByBlockId(b.getBlockId());
            String timeRange = startDateFormatter.format(b.getStartDatetime()) + "-" + endDateFormatter.format(b.getEndDatetime());
            String usage = Integer.toString(b.getUsedSlots())+"/"+((b.getMaxSlots()==-1)?"*":Integer.toString(b.getMaxSlots()));
            int[] timeArray = DataUtil.dateDifference(startDate,b.getStartDatetime());
            String timeUntil = DataUtil.getTimingShortText(timeArray);
            String timeAlertColor = DataUtil.getTimingColor(timeArray);
            String fName = f.getName();
            int frameworkId = f.getFrameworkId();
            int blockId = b.getBlockId();
            %><li><a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step2.jsp?frameworkId=<%=frameworkId%>&blockId=<%=blockId%>"><%=timeRange%> for <%=fName%></a> has <%=usage%> : <span style="color:<%=timeAlertColor%>; font-weight: bold;"><%=timeUntil%></span></li><%
    }
}
%>
</ul>

<hr>
<center><b>Signup Sheet Management</b>
<table width="90%" style="text-align: center;">
 <tr>
  <td><a href="<%=base_uri%>sheets/ss_admin_mod_sheet_main.jsp">browse/modify sheets</a></td>
  <td><a href="<%=base_uri%>groups/ss_admin_mod_group_main.jsp">browse/modify groups</a></td>
 </tr>
 <tr>
  <td><a href="<%=base_uri%>sheets/ss_admin_cr_sheet_step1.jsp">create a signup sheet</a></td>
  <td><a href="<%=base_uri%>groups/ss_admin_cr_group_step1.jsp">create a group</a></td>
 </tr>
 <tr>
  <td><a href="<%=base_uri%>slot_signups/ss_admin_signup_step1.jsp">sign up someone</a></td>
  <td><!--<a href="<%=base_uri%>reporting/ss_admin_rpt_main.jsp">reporting</a>--></td>
 </tr>
</table>
</center>

</bbUI:docTemplate>
</bbData:context>

