<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*,
                wms.ss.display.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">
<bbUI:docTemplate>

<%
try
{
User curUser = ctx.getUser();
int userPkNum = DataUtil.getPkFromBbId(curUser.getId());// Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
String course_id = request.getParameter("course_id");
String frameworkIdStr = request.getParameter("frameworkId");
int frameworkId = Integer.parseInt(frameworkIdStr);
Framework curFramework = Framework.loadByFrameworkId(frameworkId);

String blockIdStr = request.getParameter("blockId");
int blockId = (blockIdStr == null)?0:Integer.parseInt(blockIdStr);

SheetGroup group = SheetGroup.loadByFrameworkId(frameworkId);

Calendar cal = Calendar.getInstance();
java.util.Date rightNow = cal.getTime();
int frameworkTotalUsage = curFramework.usageTotalByUser(userPkNum);
int frameworkPendingUsage = curFramework.usageByUserByTimeRange(userPkNum,rightNow,null);
int groupTotalUsage = group.usageTotalByUser(userPkNum);
int groupPendingUsage = group.usageByUserByTimeRange(userPkNum,rightNow,null);

String dateCreated = SqlUtil.dateFormatter.format(curFramework.getDateCreated());
String dateUpdated = SqlUtil.dateFormatter.format(curFramework.getDateUpdated());
int ownerUserPk1 = curFramework.getOwnerUserPk1();
int groupId = curFramework.getGroupId();
String name = curFramework.getName();
String description = curFramework.getDescription();
int maxTotalSlotsPerUser = curFramework.getMaxTotalSlotsPerUser();
int maxPendingSlotsPerUser = curFramework.getMaxPendingSlotsPerUser();
String ssResource = curFramework.getResource();
String ssLocation = curFramework.getLocation();
java.util.Date signupDeadline = curFramework.getSignupDeadline();

int groupMaxTotalSlotsPerUser = group.getMaxTotalSlotsPerUser();
int groupMaxPendingSlotsPerUser = group.getMaxPendingSlotsPerUser();

if (course_id != null)
{
%>
<bbUI:breadcrumbBar handle="course_tools_area">
    <bbUI:breadcrumb href="<%=base_uri + "ss_user_class.jsp?course_id="+course_id%>">Signup Sheets</bbUI:breadcrumb>
    <bbUI:breadcrumb><%=name%></bbUI:breadcrumb>
</bbUI:breadcrumbBar>
<%
}
%>


<table>
 <tr>
  <td width="800">

<span style="float: left; font-size:24pt; font-weight:bold; font-family:arial, sans-serif;">Information for <%=name%></span>
<%
if (course_id == null)
{
    %><span style="float:right; font-size:14pt; font-weight:bold;"><a href="<%=base_uri%>sheets/ss_user_vw_sheet_main.jsp">Back to your sheets</a></span>
<%
}
%>
<br clear="all">
<span style="font-size:8pt; font-family:arial, sans-serif;">Created by <%=curFramework.getOwnerName()%> on <%=dateCreated%>.</span>

<p  style="font-size:8pt; font-family:arial, sans-serif;">
This sheet allows <%=((maxTotalSlotsPerUser<0)?"unlimited":Integer.toString(maxTotalSlotsPerUser))%> total 
signup<%=((maxTotalSlotsPerUser==1)?"":"s")%> per user, with 
<%=((maxPendingSlotsPerUser<0)?"any number":("up to "+Integer.toString(maxPendingSlotsPerUser)))%> of them for pending time blocks.


This sheet is a part of the group <%=group.getName()%>, which allows across all sheets in that group <%=((groupMaxTotalSlotsPerUser<0)?"unlimited":Integer.toString(groupMaxTotalSlotsPerUser))%> total 
signup<%=((groupMaxTotalSlotsPerUser==1)?"":"s")%> per user, with 
<%=((groupMaxPendingSlotsPerUser<0)?"any number":("up to "+Integer.toString(groupMaxPendingSlotsPerUser)))%> of them for pending time blocks.

</p>

<p style="font-size:12pt; font-family:arial, sans-serif;"><%=description%>
<%
if (ssResource.length()>0)
{
    %> This signup sheet manages access to <%=ssResource%>.<%
}
if (ssLocation.length()>0)
{
    %> Meetings for this sheet happen at <%=ssLocation%>.<%
}
if (signupDeadline != null)
{
    %> This sheet has a deadline for signups - all signups must happen by the end of <%=HtmlCalendarTool.dayOfWeekDateFormatter.format(signupDeadline)%>, <%=HtmlCalendarTool.downToDayDateFormatter.format(signupDeadline)%>.<%
}
%>
</p>

<hr>

<span style="float:left; font-size:24; font-weight:bold; font-family:arial, sans-serif; color:black;">Time blocks and signups for <%=name%></span>
<br /><br />
<!--<div style="text-align:left;">-->
<p  style="font-size:8pt; font-family:arial, sans-serif;">You are signed up <%=frameworkTotalUsage%> time<%=((frameworkTotalUsage==1)?"":"s")%> on 
this sheet, <%=frameworkPendingUsage%> of which <%=((frameworkPendingUsage==1)?"is":"are")%> pending. In this 
sheet group you are signed up <%=groupTotalUsage%> time<%=((groupTotalUsage==1)?"":"s")%>, <%=groupPendingUsage%> of which <%=((groupPendingUsage==1)?"is":"are")%> pending.
</p>
<%
boolean signupNotAllowed = false;
String limitsList = "";
if ((curFramework.getMaxTotalSlotsPerUser() >= 0) && (frameworkTotalUsage >= curFramework.getMaxTotalSlotsPerUser()))
{
    limitsList = limitsList + "<li>your total signups ("+Integer.toString(frameworkTotalUsage)+") meet or exceed the sheet limits("+Integer.toString(curFramework.getMaxTotalSlotsPerUser())+")</li>\n";
    signupNotAllowed = true;
} 
if ((curFramework.getMaxPendingSlotsPerUser() >= 0) && (frameworkPendingUsage >= curFramework.getMaxPendingSlotsPerUser()))
{
    limitsList = limitsList + " <li>your pending signups ("+Integer.toString(frameworkPendingUsage)+") meet or exceed the sheet limits("+Integer.toString(curFramework.getMaxPendingSlotsPerUser())+")</li>\n";
    signupNotAllowed = true;
} 
if ((group.getMaxTotalSlotsPerUser() >= 0) && (groupTotalUsage >= group.getMaxTotalSlotsPerUser()))
{
    limitsList = limitsList + " <li>your total signups in this group ("+Integer.toString(groupTotalUsage)+") meet or exceed the group limits("+Integer.toString(group.getMaxTotalSlotsPerUser())+")</li>\n";
    signupNotAllowed = true;
} 
if ((group.getMaxPendingSlotsPerUser() >= 0) && (groupPendingUsage >= group.getMaxPendingSlotsPerUser()))
{
    limitsList = limitsList + " <li>your pending signups in this group ("+Integer.toString(groupPendingUsage)+") meet or exceed the group limits("+Integer.toString(group.getMaxPendingSlotsPerUser())+")</li>\n";
    signupNotAllowed = true;
} 
if ((signupDeadline != null) && (rightNow.after(signupDeadline)))
{
    limitsList = limitsList + " <li>The sign up deadline has passed for this sheet</li>\n";
    signupNotAllowed = true;
} 
if (signupNotAllowed)
{
    %><div style="color: #ff0000;">You may not sign up any more times on this sheet because:
<ul>
<%=limitsList%>
</ul></div>
<%
}
%>
<!--</div>-->
<center>
<%

BlockList blocks = BlockList.loadByUserIdFrameworkId(userPkNum,frameworkId);
HtmlCalendarTool hct = new HtmlCalendarTool();
Block lastBlock = null;
for (int blockIndex = 0; blockIndex < blocks.size(); blockIndex++)
{
    Block curBlock = (Block)blocks.get(blockIndex);
    String htmlForTimeBetween = "";
    if (lastBlock==null)
    {
        out.print(hct.startCalendar(curBlock.getStartDatetime()));
    }
    else
    {
        htmlForTimeBetween = hct.emptyTimeBetween(lastBlock.getEndDatetime(),curBlock.getStartDatetime());
        out.print(htmlForTimeBetween);
    }
    String timing = hct.hourMinFormatter.format(curBlock.getStartDatetime()) + "-" + 
            hct.hourMinAmPmFormatter.format(curBlock.getEndDatetime());
    String maxSlotsText = (curBlock.getMaxSlots()<0)?"*":Integer.toString(curBlock.getMaxSlots());
    %><hr />
<%
    boolean endBlockDiv = false;
    if (blockId == curBlock.getBlockId()) // highlight last used/acted-on block
    {
        %><div style="background-color:#BBBBFF;"><% // highlight last used/active block
        endBlockDiv = true;
    }
%>
<p style="<%=hct.getCurDayTextStyle()%>">
<%
    if (curBlock.getUsedSlots() == -1)
    {
        if (! endBlockDiv)
        {
            %><div style="background-color:#BBFFFF;"><% // highlight blocks user is signed uyp for
            endBlockDiv = true;
        }
        curBlock.computeBlockUsage();
    %><%=timing%><br />
<%=curBlock.getUsedSlots()%>/<%=maxSlotsText%><br />
<%       
        SlotSignup ss = SlotSignup.loadByUserIdBlockId(userPkNum,curBlock.getBlockId());
        %><li style="<%=hct.getCurDayTextStyle()%>"><%=ss.getUserFirstName()%>&nbsp;<%=ss.getUserLastName()%><%
        if (rightNow.before(curBlock.getStartDatetime()))
        {
            %>(<a title="Delete this signup" style="color:red;" href="<%=base_uri%>slot_signups/ss_user_del_signup.jsp?slotSignupId=<%=ss.getSlotSignupId()%>&frameworkId=<%=frameworkId%>&blockId=<%=curBlock.getBlockId()%><%=(course_id != null)?"&course_id="+course_id:""%>"   onclick="return confirm('You are about to delete the signup. Click OK to do so, and Cancel to abort.')"><b>X</b></a>)<%
        }
        %></li>
<%        
    } else {
        if (((curBlock.getMaxSlots() == -1) || (curBlock.getUsedSlots() < curBlock.getMaxSlots()))
            && (! signupNotAllowed)
            && (rightNow.before(curBlock.getStartDatetime())))
        {
           %><span style="font-weight:bold; color:#005500;"><%=timing%></span><br />
<%=curBlock.getUsedSlots()%>(<a title="Sign up for this block" style="color:green;" href="<%=base_uri%>slot_signups/ss_user_signup_step1.jsp?blockId=<%=curBlock.getBlockId()%>&frameworkId=<%=frameworkId%>&signUpUserPk=<%=Integer.toString(userPkNum)%><%=(course_id != null)?"&course_id="+course_id:""%>"><b>+</b></a>)/<%=maxSlotsText%><br />
<%
        }
        else
        {
            if (! rightNow.before(curBlock.getStartDatetime()))
            {
            %><span style="<%=hct.pastDayTextStyle%>"><%=timing%><br />
<%=curBlock.getUsedSlots()%>/<%=maxSlotsText%></span><br />
<%
            } else {
            %><%=timing%><br />
<%=curBlock.getUsedSlots()%>/<%=maxSlotsText%><br />
<%
            }
        }
    }
    if (endBlockDiv)
    {
        %></div><%
    }
    
    lastBlock = curBlock;
}
if (blocks.size() > 0) {
    out.print(hct.endCalendar(lastBlock.getEndDatetime()));
} else {
    %><span style="font-size:16pt;">This sheet has no time blocks set up yet. Sorry.</span><%
}
%>  
</center>

  </td>
 </tr>
</table>
<%
}
catch (Exception e)
{
    %><hr><pre><%=e.toString()%></pre><%
    StackTraceElement[] theStackTrace = e.getStackTrace();
    for (int i = 0; i < theStackTrace.length; i++)
    {
        %><%=theStackTrace[i].toString()%><br><%
    }
}
%>

</bbUI:docTemplate>
</bbData:context>

