<%@page import="java.util.*,
                java.text.*,
                java.io.*,
                blackboard.base.*,
                blackboard.base.BbList,
                blackboard.data.*,
                blackboard.data.announcement.*,
                blackboard.data.calendar.*,
                blackboard.data.course.*,
                blackboard.data.task.*,
                blackboard.data.user.*,
                blackboard.persist.*,
                blackboard.persist.announcement.*,
                blackboard.persist.calendar.*,
                blackboard.persist.course.*,
                blackboard.persist.task.*,
                blackboard.persist.user.*,
                blackboard.platform.*,
                blackboard.platform.session.*,
                blackboard.portal.data.*, 
                blackboard.portal.servlet.*,
                wms.ss.data.*,
                wms.ss.db.*"
        errorPage="/error.jsp"
%>
<%@ taglib uri="/bbData" prefix="bbData"%>
<%@ taglib uri="/bbUI" prefix="bbUI"%>

<bbData:context id="ctx">

<%
User curUser = ctx.getUser();
String userPk = ctx.getUserId().toExternalString();
int userPkNum = Integer.parseInt(userPk.substring(1,userPk.indexOf('_',1)));
String userName = curUser.getGivenName()+" "+curUser.getFamilyName();
Course curCourse = ctx.getCourse();
String courseName = curCourse.getTitle();
String courseIdStr = ctx.getCourseId().toExternalString();
int coursePkNum = Integer.parseInt(courseIdStr.substring(1,courseIdStr.indexOf('_',1)));
String base_uri = blackboard.platform.plugin.PlugInUtil.getUriStem("wms", "wmss");
%>

<bbUI:docTemplate>
<bbUI:breadcrumbBar handle="course_tools_area">
	<bbUI:breadcrumb>Signup Sheets</bbUI:breadcrumb>
</bbUI:breadcrumbBar>

<bbUI:coursePage>

<bbUI:courseTitleBar>
Admin Signup Sheet Tool for <%=userName%> in <%=courseName%>.
</bbUI:courseTitleBar>
Upcoming signups:
<ul>
<%
Calendar cal = Calendar.getInstance();
java.util.Date startDate = cal.getTime();
int dayLookAhead = 6;
cal.add(Calendar.DATE, dayLookAhead);
BlockList bl = wms.ss.data.BlockList.loadUsedByCourseId(coursePkNum,startDate,cal.getTime());
Iterator bli = bl.listIterator();

SimpleDateFormat startDateFormatter = new SimpleDateFormat("EEEE MM/dd h:mm");
SimpleDateFormat endDateFormatter = new SimpleDateFormat("h:mm a");
if (bl.isEmpty())
{
    %><li>No blocks in the next <%=dayLookAhead%> days</li><%
}
else 
{
    while (bli.hasNext())
    {
            Block b = (Block)bli.next();
            Framework f = Framework.loadByBlockId(b.getBlockId());
            String timeRange = startDateFormatter.format(b.getStartDatetime()) + "-" + endDateFormatter.format(b.getEndDatetime());
            String usage = Integer.toString(b.getUsedSlots())+"/"+Integer.toString(b.getMaxSlots());
            int[] timeArray = DataUtil.dateDifference(startDate,b.getStartDatetime());
            String timeUntil = DataUtil.getTimingText(timeArray);
            String timeAlertColor = DataUtil.getTimingColor(timeArray);
            String fName = f.getName();
            int frameworkId = f.getFrameworkId();
            int blockId = b.getBlockId();
            %><li><a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step2.jsp?frameworkId=<%=frameworkId%>&blockId=<%=blockId%>&course_id=<%=courseIdStr%>"><%=timeRange%> for <%=fName%></a> has <%=usage%> : <span style="color:<%=timeAlertColor%>; font-weight: bold;"><%=timeUntil%></span></li><%
    }
}
%>
</ul>

<hr>

Signup sheets associated with this course:
<ul>
<%
FrameworkList fl = wms.ss.data.FrameworkList.loadByCourseIdAdminUserId(coursePkNum,userPkNum);
Iterator fli = fl.listIterator();

if (fl.isEmpty())
{
    %><li>No signup sheets associated with this course</li><%
}
else 
{
    while (fli.hasNext())
    {
        Framework f = (Framework)fli.next();
        String fName = f.getName();
        int frameworkId = f.getFrameworkId();
        %><li><a href="<%=base_uri%>sheets/ss_admin_mod_sheet_step1.jsp?frameworkId=<%=frameworkId%>&course_id=<%=courseIdStr%>"><%=fName%></a></li><%
    }
}
%>
</ul>

<hr>

<a href="<%=base_uri%>sheets/ss_admin_cr_sheet_step1.jsp?course_id=<%=courseIdStr%>&coursePk=<%=Integer.toString(coursePkNum)%>">create a signup sheet</a> | 
<a href="<%=base_uri%>slot_signups/ss_admin_signup_step1.jsp?course_id=<%=courseIdStr%>&coursePk=<%=Integer.toString(coursePkNum)%>">sign up someone</a> <!--| 
<a href="<%=base_uri%>reporting/ss_admin_rpt_main.jsp">reporting</a>-->

</bbUI:coursePage>
</bbUI:docTemplate>
</bbData:context>

