/*
 * SheetGroupList.java
 *
 * Created on August 19, 2005, 9:23 AM
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package wms.ss.data;

import java.util.ArrayList;
import wms.ss.db.Connect;
import blackboard.db.*;
import java.sql.*;

/**
 * Manages a list of SheetGroup objects. The constructor is private, so you need to
 * use the loadByX static method.
 * @author cwarren
 */
public class SheetGroupList extends java.util.ArrayList{
   
    private static String dataSourceTable = "WMS_SS_VW_GROUP_ND";
    
   /**
     * Gets a list of SheetGroups that are owned by a given user.
     * @param userPk1 A BB user PK
     * @throws blackboard.db.ConnectionNotAvailableException 
     * @throws java.lang.InterruptedException 
     * @throws java.sql.SQLException 
     * @return a SheetGroupList that has all the SheetGroups that are owned by the given user.
     */
    public static SheetGroupList loadByOwnerUserId (int userPk1)
        throws ConnectionNotAvailableException, InterruptedException, SQLException
    {
        return SheetGroupList.createFromSql("SELECT * FROM "+dataSourceTable+
                " WHERE owner_user_pk1="+Integer.toString(userPk1) + " ORDER BY name");
    }

    /** private static methods */
    private static SheetGroupList createFromSql (String sqlText)
        throws ConnectionNotAvailableException, InterruptedException, SQLException
   {
        ConnectionManager bbConnMgr = Connect.getConnectionManager();
        java.sql.Connection conn = Connect.getConnection(bbConnMgr);
        Statement sql = conn.createStatement(ResultSet.TYPE_FORWARD_ONLY, ResultSet.CONCUR_READ_ONLY);
        ResultSet res = sql.executeQuery(sqlText);

        SheetGroupList gl = new SheetGroupList();
        while (res.next())
        {
            SheetGroup g = new SheetGroup(res);
            gl.add(g);
        }
        sql.close();        
        if(bbConnMgr != null) {
            bbConnMgr.releaseConnection(conn);
        }
        
        return gl;
    }

    /** object methods */

    /** constructors */
    private SheetGroupList() {
    }
    
}
